#ifndef UISCREENINPUTDIALOG_H
#define UISCREENINPUTDIALOG_H

#include "uiscreen.h"

class UIScreenInputDialog : public UIScreen
{
public:
	UIScreenInputDialog();
	virtual ~UIScreenInputDialog();

	DEFINE_UISCREEN_FACTORY( InputDialog );

	void SetParameters(
		bool				PauseGame,
		const SimpleString&	InputString,
		const SimpleString&	InputDynamicString,
		const SimpleString& DefaultString,
		const HashedString&	OKEvent,
		const HashedString&	CancelEvent,
		const SimpleString&	OKCommand,
		const SimpleString&	CancelCommand,
		const SUICallback&	OKCallback,
		const SUICallback&	CancelCallback  );

	SimpleString 	GetString();

	virtual void 	Closed();
	void			OKCallback();
	void			CancelCallback();

private:
	HashedString		m_OKEventName;	// Event that gets fired when this screen is cancelled
	SimpleString		m_OKCommand;		// Literal console command that is issued when this cancelled
	SUICallback			m_OKCallback;		// Callback that is invoked when this screen is cancelled
	HashedString		m_CancelEventName;	// Event that gets fired when this screen is cancelled
	SimpleString		m_CancelCommand;		// Literal console command that is issued when this cancelled
	SUICallback			m_CancelCallback;		// Callback that is invoked when this screen is cancelled
};

#endif // UISCREENINPUTDIALOG_H