#include "core.h"
#include "wbactionneonawardachievement.h"
#include "configmanager.h"
#include "wbactionstack.h"
#include "reversehash.h"
#include "wbevent.h"

WBActionNeonAwardAchievement::WBActionNeonAwardAchievement()
:	m_Tag( "" )
{
}

WBActionNeonAwardAchievement::~WBActionNeonAwardAchievement()
{
}

/*virtual*/ void WBActionNeonAwardAchievement::InitializeFromDefinition( const SimpleString& DefinitionName )
{
	WBAction::InitializeFromDefinition( DefinitionName );

	MAKEHASH( DefinitionName );

	STATICHASH( AchievementTag );
	m_Tag = ConfigManager::GetString( sAchievementTag, "", sDefinitionName );
}

/*virtual*/ void WBActionNeonAwardAchievement::Execute()
{
	WBAction::Execute();

	const HashedString EventNameHash = WBActionStack::Top().GetEventName();
	const SimpleString EventName = ReverseHash::ReversedHash( EventNameHash );
	PRINTF( "Got Achievement: %s: %s\n", EventName.CStr(), m_Tag.CStr() );
}