# name of executable
ELDRITCH	=mEldritch

# additional C++ flags

# alternative hashing implementation with less collisions.
# Only use if you're doing a full conversion! You need to recompile all
# config and font files!
#CXXFLAGS 	+=-DUSE_HASH_FNV1A=1

# where to put executables
INSTDIR		=../Install
INST_EXTRA_DIR=/Extras
HTMLDIR		=../Html

# where is lib_sdl2 (includes are (currently) in the source tree
ifeq ($(PLATFORM),Windows)
LIB_SDL2	=$(TOP)/Libraries/Core/lib/SDL2.lib
else
LIB_SDL2	=-L/usr/local/lib -lSDL2
endif

# where is fmod
INC_FMODEX	=-I$(TOP)/../Dependencies/$(PLATFORM)/FMOD/inc
LIB_FMODEX	=-L$(TOP)/../Dependencies/$(PLATFORM)/FMOD/lib
LIC_FMODEX	= ../Dependencies/$(PLATFORM)/FMOD/LICENSE.TXT

ifeq ($(PLATFORM),Linux)
	LIB_FMODEX += -lfmodex64
	BIN_FMODEX  = ../Dependencies/$(PLATFORM)/FMOD/lib/libfmodex64.so
else ifeq ($(PLATFORM),MacOSX)
	LIB_FMODEX += -lfmodex
	BIN_FMODEX  = ../Dependencies/$(PLATFORM)/FMOD/lib/libfmodex.dylib
else ifeq ($(PLATFORM),Windows)
	LIB_FMODEX += -lfmodex64_vc
	BIN_FMODEX  = ../Dependencies/$(PLATFORM)/FMOD/fmodex64.dll
endif